/*
 * decompose/recompose - firmware tools
 *
 * Copyright (C) 2004 Robert Bowler
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


struct header_type 
{
  int magic;
  char vendor[20];
  char version[20];
  char model[16];
  char unknown[2];
  char image_size[10];
  char loader_addr[12];
  char loader_size[10];
  char root_fs_addr[12];
  char root_fs_size[10];
  char kernel_addr[12];
  char kernel_size[10];
  /* 138 used at this point */
  char padding1[54];
  char header_version;  /* ? at 192 */
  char padding2[3];
  unsigned int payload_checksum; /* 196 */
  char padding3[16];
  unsigned int data_checksum; /* 216 */
  char padding4[16];
  unsigned int header_checksum; /* 236 */
  char padding5[16];
};


unsigned long htocl(unsigned long x);
unsigned short htocs(unsigned short x);
unsigned crc32(unsigned char* data,
	       unsigned len);

